module Type_Check where

import JavaParser_mit_Typen

--wird importiert

--type Type = String

-- data Stmt = If(BExpr, Stmt , Maybe Stmt)
--           | While( BExpr , Stmt )
--           | Block([Stmt])
--           | Empty
--           | Return( Maybe Expr )
--           | TypedStmt(Stmt, Type)
--           deriving (Show)
          
-- data BExpr = T
--            | TypedBExpr(BExpr, Type)
--      deriving (Show)

-- data Expr = One
--           | TypedExpr(Expr, Type)
--      deriving (Show)

data Class = Class(Type, [FieldDecl], [MethodDecl]) 

data FieldDecl = FieldDecl(Type, String) 

data MethodDecl = Method(Type, String,[(Type,String)], Stmt) 





typecheckStmt :: Stmt -> [(String, Type)] -> [Class] -> Stmt
typecheckStmt (If(be, ifs, Nothing)) symtab cls =
  let
    bexp = typecheckBExpr be symtab cls
    ifstmt = typecheckStmt ifs symtab cls
  in
    if ((getTypeFromBExpr bexp) == "boolean") then
      TypedStmt(If(bexp, ifstmt, Nothing), getTypeFromStmt ifstmt)
    else                  
     error "boolean expected"

typecheckStmt (If(be, ifs, Just elses)) symtab cls =
  let
    bexp = typecheckBExpr be symtab cls
    ifstmt = typecheckStmt ifs symtab cls
    elsestmt = typecheckStmt elses symtab cls
  in
    if ((getTypeFromBExpr bexp) == "boolean") then
      if (getTypeFromStmt ifstmt) == (getTypeFromStmt elsestmt) then
        TypedStmt(If(bexp, ifstmt, Just elsestmt), getTypeFromStmt elsestmt)
      else    
        error "if und else unterschiedlich"
    else                  
     error "boolean expected"

typecheckStmt (While(be, s)) symtab cls =
  let
    bexp = typecheckBExpr be symtab cls
    stmt = typecheckStmt s symtab cls
  in
    if ((getTypeFromBExpr bexp) == "boolean") then
      TypedStmt(While(bexp, stmt), getTypeFromStmt stmt)
    else                  
     error "boolean expected"


typecheckStmt (Block(s:[])) symtab cls = typecheckStmt s symtab cls
    
typecheckStmt (Block(s:sts)) symtab cls =
  let
    stmt = typecheckStmt s symtab cls
    stmts = typecheckStmt (Block(sts)) symtab cls
  in
    if ((getTypeFromStmt stmt) == (getTypeFromStmt stmts) || (getTypeFromStmt stmt) == "void") then
       (TypedStmt(Block(s:sts), getTypeFromStmt stmts))
    else
      error "wrong types in statements"

typecheckStmt Empty symtab cls = TypedStmt(Empty, "void")

typecheckStmt (Return(Nothing)) symtab cls = TypedStmt(Return(Nothing), "void")
typecheckStmt (Return(Just e)) symtab cls = 
  let
    typedexpr = typecheckExpr e symtab cls
  in
    TypedStmt(Return (Just typedexpr), getTypeFromExpr(typedexpr))

typecheckBExpr:: BExpr -> [(String, Type)] -> [Class] -> BExpr
typecheckBExpr T symtab cls = TypedBExpr(T, "boolean")

typecheckExpr:: Expr -> [(String, Type)] -> [Class] -> Expr
typecheckExpr One symtab cls = TypedExpr(One, "integer")

getTypeFromExpr :: Expr -> Type
getTypeFromExpr (TypedExpr(_, typ)) = typ

getTypeFromBExpr :: BExpr -> Type
getTypeFromBExpr (TypedBExpr(_, typ)) = typ

getTypeFromStmt :: Stmt -> Type
getTypeFromStmt (TypedStmt(_, typ)) = typ

erste = typecheckStmt (If (T, Empty, Nothing)) [] []

dritte = typecheckStmt (If (T, Empty, Just Empty)) [] []

vierte = typecheckStmt (If (T, Empty, Just (Return (Just One)))) [] []

fuenfte = typecheckStmt (If (T, Return (Just One), Just (Return (Just One)))) [] []


main = do
  s <- readFile "fst.stmt"
  --s <- readFile "if.stmt"
  print (parser s)
  print (typecheckStmt (parser s) [] [])
